/*
AUDITUM
 26 March 2010
 created by Carla Piazza based on Garduino's code, 
 built during the phisical computing workshop with Yaniv Stenier.
 Special thanks to Tom Hulbert for his precious help programming Auditum.
 IUAV IxD Lab2 2009/2010
 Philip Tabor with Gillian Crampton Smith 
 */


///declaring all the light variables 
int buttonPin = 2;   //SWITCH connected to digital pin 2
int buttonState = 0;
int pinSecondNeon = 9;   //LIGHT2 connected to digital pin 9
int neonNumber = 0;
int neonWriting = 7;   //LatinPhraseLIGHT connected to digital pin 7
int pinNeon[] = {   //LIGHTS array
  8, 9, 10, 11,12};

///declaring all the time variables (expressed in milliseconds) 
unsigned long timeOut;
int waitForPersonDetectedTimer = 4000;
int waitBeforeLightsOnTimer = 4700;
int lightTimer = 4000;
int showWritingTimer = 15000;
int waitBeforeLightsOffTimer = 4000;

int mode = 1;

void setup(){
  pinMode (buttonPin, INPUT);   //sets the SWITCH digital pin as intput
  pinMode (pinSecondNeon, OUTPUT);   //sets the LIGHT2 digital pin as output
  pinMode (neonWriting, OUTPUT);   //sets the LatinPhraseLIGHT digital pin as output
  for (neonNumber=0; neonNumber<5; neonNumber++){ 
    pinMode (pinNeon[neonNumber], OUTPUT);//sets all the LIGHTS digital pins as output 
  }
  Serial.begin(9600);   //for the communication between Arduino and Processing
}


void loop(){
  switch (mode){
  case 1:   //switch ON light2 if someone is pressing the sensor 
    buttonState = digitalRead (buttonPin);   //read the switch input pin
    if (buttonState == HIGH){   //if the switch is on...
      timeOut = millis() + waitForPersonDetectedTimer; //...declare the timer adding 4sec to the time cycle  
      digitalWrite (pinSecondNeon, HIGH);   //and sets the light2 on
      mode = 2;   //then shifts to case 2
      Serial.println(mode);//lets communicate the Arduino current mode(2) to Processing 
    }
    break;

  case 2:   //switch OFF light2 if the sensor's pressure stops
    buttonState = digitalRead (buttonPin);   //read the switch input pin
    if (buttonState == LOW){   //if the switch is off...
      digitalWrite (pinSecondNeon,LOW);   //...sets the light2 off
      mode = 1; //then comes back to case 1
      Serial.println(mode);//lets communicate the Arduino current mode(1) to Processing 
    }
    if (millis() >= timeOut){   //if the someone si pressing the sensor for more than 4seconds then...
      digitalWrite (pinSecondNeon, LOW); //...sets the light2 off...
      delay (2000);   //...waits for 2seconds
      mode = 3;   //then shifts to case 3
      Serial.println(mode);//lets communicate the Arduino current mode(3) to Processing 
    }
    break;

  case 3:   //sequentially switch the lights ON  
    delay (waitBeforeLightsOnTimer); //waits for about 5seconds before switching on the first light
    for (neonNumber=0; neonNumber<5; neonNumber++){//sets, sequentially,the lights on
      digitalWrite (pinNeon[neonNumber], HIGH);
      delay (lightTimer);   //waits 4seconds before switching on each light
    }
    digitalWrite (neonWriting, HIGH);   //sets the LatinPhraseLIGHT on
    delay (showWritingTimer);   //waits for 15seconds
    mode = 4;   //then shifts to case 4 
    Serial.println(mode);   //lets communicate the Arduino current mode(4) to Processing
    break; 

  case 4:   //switch all the lights OFF
    delay (waitBeforeLightsOffTimer);   //waits for 4seconds
    for  (neonNumber=0; neonNumber<5; neonNumber++){   //sets simultaneously all the lights off
      digitalWrite (pinNeon[neonNumber], LOW); 
    }
    digitalWrite (neonWriting, LOW);    //sets the LatinPhraseLIGHT off at the same time of the other lights
    mode = 1;   //then shifts to case 1 and starts all again
    Serial.println(mode);   //lets communicate the Arduino current mode(1) to Processing 
  }
}



